<template>
  <lazy-new-black-theme-m-header-title
    class="common-mobile-header"
    v-if="allowTheme"
    :title="$t('withdrawal')"
    style="border-bottom: 1px solid var(--background4)"
  />
  <div v-if="isLoading" class="flex w-full h-screen">
    <div v-loading="isLoading" class="w-full"></div>
  </div>
  <template v-else>
    <div v-if="isBankMethodAvailabled" class="bg-[var(--background2)] lightblue-customize-color withdrawal-wrapper">
      <div v-if="!isShowPaymentPasswordDialog" class="divider-y">
        <div
          id="method-option"
          v-if="allowTheme"
          class="relative grid gap-2 grid-cols-2 px-2 py-2"
          style="border: none"
        >
          <nuxt-link
            v-if="isNormalBankMethodValible && isUfun"
            to="/withdrawal/bank-transfer"
          >
            <DepositTab
              :text="$t('bank_transfer')"
              :img-path="
                getAssetImage(
                  'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                )
              "
              :method-text="$t('bank_transfer')"
              :class="{ active: checkSelectedTab('bank-transfer') }"
            />
          </nuxt-link>
          <template
            v-for="paymentMethod in paymentBanks.PaymentMethodsForWithdrawal"
            :key="paymentMethod.PaymentMethodId"
          >
            <nuxt-link
              v-if="isPaymentBankMethodValible"
              :to="'/withdrawal/payment-bank/' + paymentMethod.PaymentMethod"
            >
              <DepositTab
                :text="paymentMethod.PaymentMethodDisplayName"
                :img-path="paymentMethod?.PaymentMethodIconUrl"
                :method-text="paymentMethod?.PaymentMethodDisplayName"
                :class="{
                  active: checkSelectedTab(paymentMethod.PaymentMethod),
                }"
              />
            </nuxt-link>
          </template>
          <nuxt-link
            v-if="isNormalBankMethodValible && !isUfun"
            to="/withdrawal/bank-transfer"
          >
            <DepositTab
              :text="$t('bank_transfer')"
              :img-path="
                getAssetImage(
                  'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                )
              "
              :method-text="$t('bank_transfer')"
              :class="{ active: checkSelectedTab('bank-transfer') }"
            />
          </nuxt-link>
        </div>
        <ul
          v-else
          class="grid grid-cols-2 gap-2 px-5 py-6 payment-method-group"
        >
          <nuxt-link
            v-if="isNormalBankMethodValible && isUfun"
            to="/withdrawal/bank-transfer"
            active-class="selected"
          >
            <img
              class="absolute check-img"
              :src="getAssetImage('assets/svg-icon/checked.svg')"
              alt="check"
            />
            <div class="icon">
              <img
                :src="
                  getAssetImage(
                    'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                  )
                "
              />
            </div>
            {{ $t("bank_transfer") }}
          </nuxt-link>
          <template v-if="isPaymentBankMethodValible">
            <nuxt-link
              v-for="paymentMethod in paymentBanks.PaymentMethodsForWithdrawal"
              :key="paymentMethod.PaymentMethodId"
              :to="'/withdrawal/payment-bank/' + paymentMethod.PaymentMethod"
              active-class="selected"
            >
              <img
                class="absolute check-img"
                :src="getAssetImage('assets/svg-icon/checked.svg')"
                alt="check"
              />
              <div class="icon">
                <img :src="paymentMethod.PaymentMethodIconUrl" />
              </div>
              {{ paymentMethod.PaymentMethodDisplayName }}
            </nuxt-link>
          </template>
          <nuxt-link
            v-if="isNormalBankMethodValible && !isUfun"
            to="/withdrawal/bank-transfer"
            active-class="selected"
          >
            <img
              class="absolute check-img"
              :src="getAssetImage('assets/svg-icon/checked.svg')"
              alt="check"
            />
            <div class="icon">
              <img
                :src="
                  getAssetImage(
                    'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                  )
                "
              />
            </div>
            {{ $t("bank_transfer") }}
          </nuxt-link>
        </ul>
        <div class="mb-[12vw] lightblue-customize-color h-screen unset-height unset-padding-b">
          <nuxt-page
            class="pb-52 unset-padding-b transaction-form-section"
            :paymentBanks="paymentBanks"
            :normalBanks="normalBanks"
            :profile="profile"
            :isWithdrawalLimitEnabled="isWithdrawalLimitEnabled"
            :isPaymentPasswordEnable="isPaymentPasswordEnable"
          ></nuxt-page>
        </div>
      </div>
    </div>
    <div v-else class="px-5 py-6 flex justify-center lightblue-customize-color">
      <span>
        {{ $t("no_available_method_to_do_the_transaction") }}
      </span>
    </div>
    <el-dialog
      v-model="isShowPaymentPasswordDialog"
      :show-close="false"
      :close-on-click-modal="false"
      width="80%"
      top="10vh"
      custom-class="no-header lightblue-customize-color"
    >
      <div class="mb-4">{{ alertMessage }}</div>
      <div>
        <el-form
          label-position="top"
          label-width="200px"
          :model="formData"
          :rules="getRule"
          ref="ruleFormRef"
          style="max-width: 550px"
          :validate-on-rule-change="false"
        >
          <el-form-item :label="paymentPasswordLabel" prop="paymentPassword">
            <el-input v-model="formData.paymentPassword" type="password" />
          </el-form-item>
          <el-form-item
            :label="confirmPaymentPasswordLabel"
            prop="confirmPaymentPassword"
          >
            <el-input
              v-model="formData.confirmPaymentPassword"
              type="password"
            />
          </el-form-item>
          <el-form-item :label="loginPasswordLabel" prop="loginPassword">
            <el-input v-model="formData.loginPassword" type="password" />
          </el-form-item>
        </el-form>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <div class="text-center flex items-center justify-center gap-3">
            <el-button type="danger" @click="goHome" round>{{
              $t("cancel")
            }}</el-button>
            <el-button
              type="primary"
              @click="submitWithdrawal(ruleFormRef)"
              class="submit-btn"
              round
            >
              {{ $t("submit") }}
            </el-button>
          </div>
        </span>
      </template>
    </el-dialog>
  </template>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { Navigation } from "swiper";
import DepositTab from "../deposit/DepositTab.client.vue";
import { useWithdrawal } from "@/composables/payment/withdrawal/useWithdrawal";
import { store } from "@/store";

export default defineComponent({
  name: "MobileWithdrawal",
  components: {
    DepositTab,
  },
  setup() {
    const {
      paymentBanks,
      normalBanks,
      isNormalBankMethodValible,
      isPaymentBankMethodValible,
      paymentPasswordLabel,
      confirmPaymentPasswordLabel,
      loginPasswordLabel,
      alertMessage,
      formData,
      isShowPaymentPasswordDialog,
      submitWithdrawal,
      getRule,
      ruleFormRef,
      isPaymentPasswordEnable,
      profile,
      isWithdrawalLimitEnabled,
      isLoading,
      isBankMethodAvailabled,
      isUfun,
    } = useWithdrawal();
    const { getAssetImage } = commonHelper;
    const allowThemes = ["main", "black", "china", "sbo", 'global', 'playful'];
    const allowTheme = computed(() =>
      allowThemes.includes(store.state.selectedThemeName)
    );
    const route = useRoute();
    const router = useRouter();
    const checkSelectedTab = (params: string) => {
      if (route.fullPath.toLocaleLowerCase().includes(params)) {
        return true;
      }
      return false;
    };
    const goHome = () => {
      router.push("/");
    };
    return {
      paymentBanks,
      normalBanks,
      isNormalBankMethodValible,
      isPaymentBankMethodValible,
      paymentPasswordLabel,
      confirmPaymentPasswordLabel,
      loginPasswordLabel,
      alertMessage,
      formData,
      isShowPaymentPasswordDialog,
      submitWithdrawal,
      getRule,
      ruleFormRef,
      isPaymentPasswordEnable,
      profile,
      isWithdrawalLimitEnabled,
      isLoading,
      getAssetImage,
      isBankMethodAvailabled,
      allowTheme,
      checkSelectedTab,
      modules: [Navigation],
      goHome,
      isUfun,
    };
  },
});
</script>

<style lang="scss">
[theme-color="main_lightblue"] {
  .lightblue-customize-color {
    color: #FFFFFF;
    background-color: var(--background5);

    .el-form-item__label {
      color: #FFFFFF;
    }

    .el-input__inner {
      color: var(text4_w);
      background-color: rgba($color: #000000, $alpha: 0.1)
    }
  }
}
[theme-color="china"] {
  .withdrawal-wrapper {
    #method-option,
    .transaction-form-section {
      background: var(--background5) !important;
    }
  }
}
[layout="sbo"] {
  .transaction-form-section {
    padding-bottom: 350px;
  }
}
</style>

<style scoped lang="scss">
:deep(.el-button.el-button--primary.is-round.submit-btn) {
  width: unset;
  height: unset;
  margin-left: 0;
}
</style>
